#!/usr/bin/perl -w
#
# downinch.pl - downcase #include directives in .h and .cpp files
#
# match the following:
#   line contains #include
#   one or more whitespace (\s)
#   angle brackets or double quotes start (< or ")
#   any text
#   angle brackets or double quotes stop (> or ")
#
# (C) 2001 Alfred E. Heggestad
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#

@ARGV == 1 or die "usage: $0 <file>\n";
$file = $ARGV[0];

# no \n delimiters
undef $/; # alias $INPUT_RECORD_SEPARATOR, $RS

#
# open and slurp the file into $_
#
open(FIN, $file) or die "Error: $!\n";
$_ = <FIN>;
close FIN;

#
# do the regexp here
# suffix: globally and multiline
#
$broken = s/(include\s*[<"].*[A-Z]+.*[>"])/lc $1/gme; # <--- this works
#$broken = s/(include\s*[<"].*[A-Z]+.*[>"])/$1/gme;

#
# open the file again and overwrite it
# (only if it was broken)
#
if($broken){
  print "broken = $file\n";
  open FOUT, ">$file";
  print FOUT;
  close FOUT;
}