#!/usr/bin/perl -w
#
# gplify.pl - append the GPL to files if not there.
#             it can also check your files. use like this:
#
#    find . -name "*.cpp" -exec gplify.pl '{}' -c \;
#
# (c) 2001-2002 Alfred E. Heggestad
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#

my $GPL = "//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//

";

my @HINTS = ("This program is free software",
             "under the terms of the GNU General Public License",
             "Free Software Foundation");


@ARGV >= 1 or die "usage: $0 <file> [options]\n  -c   check only, do not change file\n";
$file = $ARGV[0];

# no \n delimiters
undef $/; # alias $INPUT_RECORD_SEPARATOR, $RS

#
# open and slurp the file into $_
#
open(FIN, $file) or die "Error: $!\n";
$_ = <FIN>;
close FIN;

my $probability = 0;

foreach $hint (@HINTS) {
#  print "checking hint: $hint\n";
  $probability++ if /$hint/;
}

$NO_HINTS = scalar @HINTS;
my $percentage = 100 * $probability / $NO_HINTS;
#print "Number of hints: $NO_HINTS\n";

my $is_there = 1;

if($probability==0){
  print "WARNING! $file does not contain the GPL\n";
}elsif($probability==$NO_HINTS){
  print "OK $file\n";
  exit;
}else{
  print "perhaps it is there? You have to check yourself (probability=$percentage)\n";
  exit;
}

#
# exit if -c specified
#
if(defined $ARGV[1] && $ARGV[1]=~/-c/) {
  exit;
}


#
# at this point we know there are absolutely no GPL in
# the file, so apply it somewhere.
#

#print "File format: ", m/"\r\n"/ ? "DOS\n" : "Unix\n"; ???

$match = s-//\r\n\r\n-$GPL-m;

if($match) {
  print "Found match! hurrah\n" if ($match);
  open FOUT, ">$file" or die "Could not open $file due to $!";
  print FOUT;
  close FOUT;
} else {
  print "WARNING! I was not clever enough to find where to inject the GPL...\n";
}






