#! /bin/bash
#
# unixifygcc.sh - Make the EPOC SDK useful for Unix
#
# (c) 2000-2001 Patrick C. Regnouf
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#
# This program does the following:
#
#   o Set the relevant file attributes
#   o Convert all files from DOS to Unix
#  	
# When you download er5 SDK (from http://www.symbiandevnet.com) and unzip it, 
# it creates a zip/ directory in which you will find the source code of 
# gcc (gcc_<Version Number>.zip>, this file contains in 
# fact the source code of a customised version of cygnus tools for Windows.
#
# When you unzip this file to compile gcc for cross compiling for ARM under Linux
# you will have the source code of all the cygnus tools ready to be compiled .
#
# One big surprise awaits you though, all files, INCLUDING SHELL SCRIPTS are in MS-DOS
# format (i.e CR/LF pair at the end of each line) that means that bash does not 
# understand the #!/bin/sh line and returns an error that might be difficult to track
# (file not found) when you attempt to execute the script ...
#
# To remedy this, once you have unzipped gcc_<version Number>.zip, just cd to the newly
# created src/ directory and launch this script
#


#
# recursively convert MS-DOS files to Unix format.
# text files only
#

echo 'Converting text files to Unix format'
FILES=$(find . -name '*')

for n in $FILES
do echo doing $n
perl -pi -e 's/\r\n/\n/' $n
done
